#include <SDL.h>
#include "xboxJoy.h"
#include "xresizer.h"

Uint8* pollJoypad(SDL_Event *eventPtr)
{
	unsigned int XPAD;

	SDL_PumpEvents();
	SDL_JoystickUpdate();

	Uint8 *keys = SDL_GetKeyState(NULL);
	keys[SDLK_UP]		= false;
	keys[SDLK_DOWN]		= false;
	keys[SDLK_LEFT]		= false;
	keys[SDLK_RIGHT]	= false;
	keys[SDLK_LCTRL]    = false;
	keys[SDLK_ESCAPE]   = false;
	keys[SDLK_LALT]     = false;

	SDL_Event event;
	SDL_PollEvent(&event);

	Uint8 BUTTON_RSTCIK = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_RSTICK);
	Uint8 BUTTON_Y = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_Y);
	Uint8 BUTTON_B = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_B);
	Uint8 BUTTON_START = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_START);
	Uint8 BUTTON_BACK = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_BACK);
	Uint8 BUTTON_WHITE = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_WHITE);
	Uint8 BUTTON_BLACK = SDL_JoystickGetButton(JOYPAD, JOY_BTTN_BLACK);

	if(BUTTON_B == 1 || BUTTON_BACK == 1 || BUTTON_START == 1 || BUTTON_RSTCIK == 1 || BUTTON_WHITE == 1 || BUTTON_BLACK == 1 || BUTTON_Y == 1)
	{
		if(BUTTON_START)
		{
			event.key.keysym.sym = SDLK_LALT;
			keys[SDLK_LALT] = SDL_PRESSED;
		}

		if(BUTTON_Y)
		{
			event.key.keysym.sym = SDLK_m;
			keys[SDLK_m] = SDL_PRESSED;
		}

		if(BUTTON_B)
		{
			event.key.keysym.sym = SDLK_LCTRL;
			keys[SDLK_LCTRL] = SDL_PRESSED;
		}

		if(BUTTON_BACK)
		{
			event.key.keysym.sym = SDLK_ESCAPE;
			keys[SDLK_ESCAPE] = SDL_PRESSED;
		}

		if(BUTTON_WHITE)
		{
			event.key.keysym.sym = SDLK_s;
			keys[SDLK_s] = SDL_PRESSED;
		}

		if(BUTTON_BLACK)
		{
			event.key.keysym.sym = SDLK_o;
			keys[SDLK_o] = SDL_PRESSED;
		}
		
		if(BUTTON_RSTCIK)
		{
			resize_screen();
		}

		event.type = SDL_KEYDOWN;
	}

	XPAD   = SDL_JoystickGetHat (JOYPAD, 0);

	if(XPAD != 0)
	{
		switch(XPAD)
		{
		case SDL_HAT_UP:
			keys[SDLK_UP]     = SDL_PRESSED;
			break;
		case SDL_HAT_DOWN:
			keys[SDLK_DOWN]     = SDL_PRESSED;
			break;
		case SDL_HAT_LEFT:
			keys[SDLK_LEFT]     = SDL_PRESSED;
			break;
		case SDL_HAT_RIGHT:
			keys[SDLK_RIGHT]     = SDL_PRESSED;
			break;
		case SDL_HAT_RIGHTUP:
			keys[SDLK_UP]   = SDL_PRESSED;
			keys[SDLK_RIGHT]  = SDL_PRESSED;
			break;
		case SDL_HAT_RIGHTDOWN:
			keys[SDLK_DOWN]   = SDL_PRESSED;
			keys[SDLK_RIGHT]  = SDL_PRESSED;
			break;
		case SDL_HAT_LEFTUP:
			keys[SDLK_UP]    = SDL_PRESSED;
			keys[SDLK_LEFT]  = SDL_PRESSED;
			break;
		case SDL_HAT_LEFTDOWN:
			keys[SDLK_DOWN]    = SDL_PRESSED;
			keys[SDLK_LEFT]  = SDL_PRESSED;
			break;
		}

		event.type = SDL_KEYDOWN;
	}

	*eventPtr = event;
	return keys;
}