#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL_Image.h>
#include "xboxJoy.h"

int axisL, axisLY, axisR, axisRY;
int xpos=0, ypos=0, xstretch=0, ystretch=0; 

void saveScreen()
{
	FILE *fp;

	fp=fopen("U:\\screensize.xsv","w+");

	fprintf(fp, "XPOS=%d\n", xpos);
	fprintf(fp, "YPOS=%d\n", ypos);
	fprintf(fp, "XSTRETCH=%d\n", xstretch);
	fprintf(fp, "YSTRETCH=%d\n", ystretch);

	fclose(fp);

	return;

}
void loadScreen()
{
	char str[500];
	FILE * fi;
	fi = fopen("U:\\screensize.xsv", "r");


	if(fi != NULL) 
	{
		do
		{
			fgets(str, sizeof(str), fi);
			if (!feof(fi))
			{

				if (strstr(str, "XPOS=") == str){

					xpos = atoi(str + 5);

				}
				else if (strstr(str, "YPOS=") == str){

					ypos = atoi(str + 5);

				}
				else if (strstr(str, "XSTRETCH=") == str){

					xstretch = atoi(str + 9);

				}
				else if (strstr(str, "YSTRETCH=") == str){

					ystretch = atoi(str + 9);

				}

			}

		}
		while (!feof(fi));

		fclose(fi);
	}

	//If user has changed screen size
	if((xstretch + ystretch + xpos + ypos) != 0)
	{
		//Set Screen Size 
		SDL_XBOX_SetScreenStretch(xstretch, ystretch);
		SDL_XBOX_SetScreenPosition(xpos, ypos);

	}
	else
	{
		SDL_XBOX_SetScreenStretch(-36, -27);
		SDL_XBOX_SetScreenPosition(17, 15);
	}

	return;
}

extern SDL_Surface *video;
extern SDL_Joystick *JOYPAD;
void resize_screen()
{
	int done = 0, button;
	SDL_Rect src, dest;
	SDL_Event sdlEvent;

	SDL_Surface * IMG_RESIZE;

	IMG_RESIZE = IMG_Load("D:\\art\\resize.png");

	dest.x = 0;
	dest.y = 0;
	dest.w = 640;
	dest.h = 480;

	SDL_FillRect(video, &dest,
		SDL_MapRGB(video->format, 0x00, 0x00, 0x00));
	src.x = 0;
	src.y = 0;
	src.w = IMG_RESIZE->w;
	src.h = IMG_RESIZE->h;
	dest.x = 0;
	dest.y = 0;
	dest.w = IMG_RESIZE->w;
	dest.h = IMG_RESIZE->h;
	SDL_BlitSurface(IMG_RESIZE, NULL, video, &dest);
	SDL_UpdateRect(video, 0, 0, 640, 480);//x,y


	do{

		axisL = SDL_JoystickGetAxis(JOYPAD, JOY_AXIS_LX);
		axisLY = SDL_JoystickGetAxis(JOYPAD, JOY_AXIS_LY);
		axisR = SDL_JoystickGetAxis(JOYPAD, JOY_AXIS_RX);
		axisRY = SDL_JoystickGetAxis(JOYPAD, JOY_AXIS_RY);               

		if (axisLY < -JOY_DEADZONE)
		{
			xstretch -= 4;

		}
		else if (axisLY > JOY_DEADZONE)
		{
			xstretch += 4;
		}

		ystretch = (xstretch*.75);

		//Screen RePosition
		if (axisR < -JOY_DEADZONE)
		{
			xpos = xpos - 1;
		}

		else if (axisR > JOY_DEADZONE)
		{
			xpos = xpos + 1;
		}

		else if (axisRY < -JOY_DEADZONE)
		{
			ypos = ypos - 1;
		}
		else if (axisRY > JOY_DEADZONE)
		{
			ypos = ypos + 1;
		}

		while (SDL_PollEvent(&sdlEvent)){

			if (sdlEvent.type == SDL_JOYBUTTONDOWN)
			{
				button = sdlEvent.jbutton.button;

				if (button == JOY_BTTN_A)
				{
					done = 1;
				}

				if (button == JOY_BTTN_LSTICK)
				{
					SDL_XBOX_SetScreenStretch(-36, -27);
					SDL_XBOX_SetScreenPosition(17, 15);
				}
			}
		}

		SDL_XBOX_SetScreenPosition(xpos, ypos);
		SDL_XBOX_SetScreenStretch(xstretch, ystretch);

		SDL_Flip(video);
	}
	while (done == 0);

	saveScreen();
	SDL_FreeSurface(IMG_RESIZE);

	return;
}